/*
 * ProductView.java
 *
 * Created on 10 de agosto de 2004, 18:06
 */

package com.fenalco.servlets.supplier;

import java.io.File;
import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.SupplierProduct;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;

/**
 * Este servlet construye la información necesaria para que <CODE>producto.jsp
 * </CODE> muestre al proveedor la información almacenada del producto en el
 * sistema.
 * 
 * @author andres
 */
public class ProductView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Para entregar la información completa de un producto construye un objeto
	 * <CODE>SupplierProduct</CODE> que recibe el id del producto de proveedor
	 * y un objeto <CODE>Product</CODE> con el id de un producto general para
	 * obtener tanto la información general del producto, como información
	 * específica como escalas de precios y descuentos.
	 * 
	 * Ambos objetos son enviados a <CODE>producto.jsp</CODE> como atributos
	 * de response
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

		boolean hasImage = false;

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				SupplierProduct supplierProduct = new SupplierProduct(Integer
						.parseInt(request.getParameter("key")));
	
				url = "/proveedor/producto.jsp";
				if( supplierProduct == null )
				{
					//Fallo en la carga de la informaciòn del producto
					//message = "Fallo en la carga de la información del producto";
					message = MessageBuilder.buildMessage(6);
					hasImage = false;
	
				}
				else
				{
					//Todo OK
					//message = "La carga del producto terminó correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
	
					// voy a mirar si el producto tiene imagen
					String path = getServletContext().getRealPath(
							supplierProduct.getImage());
					File file = new File(path);
					if( file.isFile() )
					{
						hasImage = true;
					}
					else
					{
						hasImage = false;
					}
	
					request.setAttribute("product", supplierProduct);
				}
			}
	
			request.setAttribute("hasImage", new Boolean(hasImage));
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}